//
//  Shader_Blitter_Textured.fsh
//
//  Copyright (c) 2012 Midoki Ltd. All rights reserved.
//

varying lowp vec4 colorVarying;
varying mediump vec2 texCoordVarying;

uniform sampler2D baseTexture;

void main()
{
	mediump vec2 texelOffset = (colorVarying.xy * colorVarying.xy) * colorVarying.w;

	// 5-tap kernel... (0.06136	0.24477	0.38774	0.24477	0.06136)
#define TAP5_OFFSET1 1.00000
#define TAP5_OFFSET2 2.00000

	mediump vec4 texel = (texture2D(baseTexture, texCoordVarying) * 0.38774);

	texel += (texture2D(baseTexture, texCoordVarying - (texelOffset * TAP5_OFFSET1)) * 0.24477);
	texel += (texture2D(baseTexture, texCoordVarying + (texelOffset * TAP5_OFFSET1)) * 0.24477);

	texel += (texture2D(baseTexture, texCoordVarying - (texelOffset * TAP5_OFFSET2)) * 0.06136);
	texel += (texture2D(baseTexture, texCoordVarying + (texelOffset * TAP5_OFFSET2)) * 0.06136);
    
    gl_FragColor = vec4(texel.xyz, colorVarying.w);
}
