//
//  Shader_Blitter_Textured.fsh
//
//  Copyright (c) 2012 Midoki Ltd. All rights reserved.
//

varying lowp vec4 colorVarying;
varying mediump vec2 texCoordVarying;

uniform sampler2D baseTexture;

void main()
{
	mediump vec2 texelOffset = (colorVarying.xy * colorVarying.xy) * colorVarying.w;

    // 7-tap kernel... (0.038735    0.113085    0.215007    0.266346    0.215007    0.113085    0.038735)
#define TAP7_OFFSET1 0.66667    //(1.0 * (2.0/3.0))
#define TAP7_OFFSET2 1.33333    //(2.0 * (2.0/3.0))
#define TAP7_OFFSET3 2.00000    //(3.0 * (2.0/3.0))

    mediump vec4 texel = (texture2D(baseTexture, texCoordVarying) * 0.266346);

    texel += (texture2D(baseTexture, texCoordVarying - (texelOffset * TAP7_OFFSET1)) * 0.215007);
    texel += (texture2D(baseTexture, texCoordVarying + (texelOffset * TAP7_OFFSET1)) * 0.215007);

    texel += (texture2D(baseTexture, texCoordVarying - (texelOffset * TAP7_OFFSET2)) * 0.113085);
    texel += (texture2D(baseTexture, texCoordVarying + (texelOffset * TAP7_OFFSET2)) * 0.113085);

    texel += (texture2D(baseTexture, texCoordVarying - (texelOffset * TAP7_OFFSET3)) * 0.038735);
    texel += (texture2D(baseTexture, texCoordVarying + (texelOffset * TAP7_OFFSET3)) * 0.038735);

    gl_FragColor = vec4(texel.xyz, colorVarying.w);
}
