//
//  Shader_Blitter_Textured.fsh
//
//  Copyright (c) 2012 Midoki Ltd. All rights reserved.
//

varying lowp vec4 colorVarying;
varying mediump vec2 texCoordVarying;

uniform sampler2D baseTexture;

void main()
{
	mediump vec2 texelOffset = (colorVarying.xy * colorVarying.xy) * colorVarying.w;

    // 9-tap kernel... (0.028532    0.067234    0.124009    0.179044    0.20236    0.179044    0.124009    0.067234    0.028532)
#define TAP9_OFFSET1 0.5    //(1.0 * (2.0/4.0))
#define TAP9_OFFSET2 1.0    //(2.0 * (2.0/4.0))
#define TAP9_OFFSET3 1.5    //(3.0 * (2.0/4.0))
#define TAP9_OFFSET4 2.0    //(3.0 * (2.0/4.0))

    mediump vec4 texel = (texture2D(baseTexture, texCoordVarying) * 0.20236);

    texel += (texture2D(baseTexture, texCoordVarying - (texelOffset * TAP9_OFFSET1)) * 0.179044);
    texel += (texture2D(baseTexture, texCoordVarying + (texelOffset * TAP9_OFFSET1)) * 0.179044);

    texel += (texture2D(baseTexture, texCoordVarying - (texelOffset * TAP9_OFFSET2)) * 0.124009);
    texel += (texture2D(baseTexture, texCoordVarying + (texelOffset * TAP9_OFFSET2)) * 0.124009);

    texel += (texture2D(baseTexture, texCoordVarying - (texelOffset * TAP9_OFFSET3)) * 0.067234);
    texel += (texture2D(baseTexture, texCoordVarying + (texelOffset * TAP9_OFFSET3)) * 0.067234);

    texel += (texture2D(baseTexture, texCoordVarying - (texelOffset * TAP9_OFFSET4)) * 0.028532);
    texel += (texture2D(baseTexture, texCoordVarying + (texelOffset * TAP9_OFFSET4)) * 0.028532);

    gl_FragColor = vec4(texel.xyz, colorVarying.w);
}
