//
//  Shader_Blitter_Untextured.fsh
//
//  Copyright (c) 2012 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

#define SHADER_DISSOLVE

#define lerp(x,y,a) mix(x,y,a)

//------------------------------------------------------------------------------

uniform sampler2D uniform_texture0;

#if defined (SHADER_DISSOLVE)
uniform sampler2D uniform_alphamap;
#endif

#if defined (SHADER_DISSOLVE)
uniform mediump vec4 uniform_emissiveColour;
#endif

//------------------------------------------------------------------------------

varying lowp vec4 varying_colour;
varying mediump vec2 varying_uv0;

#if defined (SHADER_DISSOLVE)
varying mediump vec2 varying_dissolve;
#endif

//------------------------------------------------------------------------------

void main()
{
    mediump vec4 diffuseTexel = texture2D(uniform_texture0, varying_uv0);
    
    mediump vec4 finalRGBA = diffuseTexel;

#if defined (SHADER_DISSOLVE)
    mediump vec4 dissolveTexel = texture2D(uniform_alphamap, varying_uv0);
    mediump float dissolveAlpha = step(varying_dissolve.x, dissolveTexel.x);
    if (dissolveAlpha <= 0.0)
    {
        discard;
    }
    mediump float dissolveSolid = step(varying_dissolve.y, dissolveTexel.x);
    mediump float dissolveMix = (dissolveAlpha - dissolveSolid);

    finalRGBA.xyz *= dissolveSolid;
    finalRGBA.xyz += (uniform_emissiveColour.xyz * dissolveMix);
    finalRGBA.w *= dissolveAlpha;
#endif
    
    gl_FragColor = finalRGBA;
}

//------------------------------------------------------------------------------
