//
//  Shader_Blitter_Untextured.fsh
//
//  Copyright (c) 2012 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

uniform sampler2D uniform_texture0;
uniform sampler2D uniform_ambientmap;

uniform mediump vec4 uniform_fireSettings1;
uniform mediump vec4 uniform_fireSettings2;
uniform mediump vec4 uniform_fireSettings3;

//------------------------------------------------------------------------------

varying lowp vec4 varying_colour;
varying mediump vec2 varying_uv0;
varying mediump vec2 varying_uv1;
varying mediump vec2 varying_uv2;

//------------------------------------------------------------------------------

void main()
{
    mediump vec4 distortTexel0 = texture2D(uniform_ambientmap, varying_uv0);
    mediump vec4 distortTexel1 = texture2D(uniform_ambientmap, varying_uv1);
    mediump vec4 distortTexel2 = texture2D(uniform_ambientmap, varying_uv2);

    highp float val = (distortTexel1.x +  distortTexel2.y);
    val *= uniform_fireSettings1.w;
    val -= uniform_fireSettings2.w;
    val *= distortTexel0.w;
    val *= distortTexel0.z;

    highp vec2 colourUV = vec2(varying_uv0.x, (varying_uv0.y - val)); //-V

    mediump vec4 colourTexel = texture2D(uniform_texture0, colourUV);

	if (colourTexel.w < 0.5)
	{
		discard;
	}

    mediump vec4 finalRGBA = colourTexel;
    
    finalRGBA.xyz  = (colourTexel.x * uniform_fireSettings1.xyz);
    finalRGBA.xyz += (colourTexel.y * uniform_fireSettings2.xyz);
    finalRGBA.xyz += (colourTexel.z * uniform_fireSettings3.xyz);
    finalRGBA.w = 1.0;
    
    gl_FragColor = finalRGBA;
}

//------------------------------------------------------------------------------
