//
//  Shader_Blitter_3d_Untextured.vsh
//
//  Copyright (c) 2012 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

#define DECOMPRESSION_MULTIPLIER_POSITION   (1.0 / 32767.0)
#define DECOMPRESSION_MULTIPLIER_UV         (1.0 / 1024.0)

//------------------------------------------------------------------------------

attribute highp vec4 attrib_position;
attribute highp vec3 attrib_normal;
//attribute highp vec4 attrib_rgba;
attribute highp vec2 attrib_uv0;

//------------------------------------------------------------------------------

uniform highp mat4 uniform_modelViewProjectionMatrix;
uniform highp vec4 uniform_animUV;

uniform mediump vec4 uniform_fireSettings3;

//------------------------------------------------------------------------------

varying lowp vec4 varying_colour;
varying mediump vec2 varying_uv0;
varying mediump vec2 varying_uv1;
varying mediump vec2 varying_uv2;

//------------------------------------------------------------------------------

void main()
{
//    varying_colour = vec4(attrib_rgba.xyz, 1.0);
    varying_colour = vec4(1.0, 1.0, 1.0, 1.0);

    // Set up the animated uv coordinates...
    mediump vec2    baseUVOffset1 = fract(uniform_animUV.xy * vec2(uniform_fireSettings3.w, -uniform_animUV.z)); //-V
    mediump vec2    baseUVOffset2 = fract(uniform_animUV.xy * vec2(uniform_fireSettings3.w, -uniform_animUV.w)); //-V

    varying_uv0 = (attrib_uv0 * DECOMPRESSION_MULTIPLIER_UV);
    varying_uv1 = (varying_uv0 + baseUVOffset1);
    varying_uv2 = (varying_uv0 + baseUVOffset2);

    highp vec3      posScaled   = (attrib_position.xyz * (attrib_position.w * DECOMPRESSION_MULTIPLIER_POSITION));
    highp vec4      posScaled4  = vec4(posScaled, 1.0);

    gl_Position = (uniform_modelViewProjectionMatrix * posScaled4);
}

//------------------------------------------------------------------------------
