//
//  Shader_Blitter_Untextured.fsh
//
//  Copyright (c) 2012 Midoki Ltd. All rights reserved.
//

varying lowp vec4 varying_colour;
varying mediump vec3 varying_normal;

uniform highp vec3 uniform_sunColour;
uniform highp vec4 uniform_sunHazeColour;
uniform highp vec3 uniform_sunSettings;
uniform highp vec4 uniform_horizonColourBlend;
uniform highp vec4 uniform_horizonLightning;

void main()
{
	mediump float sunInner = uniform_sunSettings.x;
	mediump float sunOuter = uniform_sunSettings.y;
	mediump float hazeOuter = uniform_sunSettings.z;
	mediump float hazeIntensity = uniform_sunHazeColour.w;

	mediump vec3 normalN = normalize(varying_normal);
	
	mediump vec3 finalRGB = varying_colour.xyz;
	
	mediump float lightningDot = max(0.0, -dot(normalN, uniform_horizonLightning.xyz));
	mediump float lightningFactor = clamp(((lightningDot - (1.0 - uniform_horizonLightning.w)) / uniform_horizonLightning.w), 0.0, 1.0);
	finalRGB += ((lightningFactor * lightningFactor) * uniform_horizonLightning.w * 0.5);
	
    mediump float grey = dot(vec3(0.3, 0.59, 0.51), vec3(finalRGB));
    mediump vec3 tintedRGB = vec3(grey, grey, grey) * uniform_horizonColourBlend.xyz;
    finalRGB *= (1.0 - uniform_horizonColourBlend.w);
    finalRGB += (tintedRGB * uniform_horizonColourBlend.w);
    
    gl_FragColor = vec4(finalRGB, 1.0);
}
