//
//  Shader_Blitter_Untextured.fsh
//
//  Copyright (c) 2012 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

uniform sampler2D uniform_diffusemap;
uniform sampler2D uniform_normalmap;

uniform mediump vec4 uniform_portalSettings;

//------------------------------------------------------------------------------

varying lowp vec4 varying_colour;
varying mediump vec2 varying_uv0;
varying mediump vec2 varying_uv1;

//------------------------------------------------------------------------------

void main()
{
    mediump vec4 distortTexel = texture2D(uniform_normalmap, varying_uv1);
    
    mediump vec2 distorted_uv0 = (varying_uv0 + (distortTexel.xy * uniform_portalSettings.z * vec2(1.0, -1.0)));
    distorted_uv0 = clamp(distorted_uv0, 0.01, 0.99);
    
    mediump vec4 diffuseTexel = texture2D(uniform_diffusemap, distorted_uv0);

    mediump vec4 finalRGBA = diffuseTexel * varying_colour;
    
    gl_FragColor = finalRGBA;
}

//------------------------------------------------------------------------------
