//
//  Shader_Blitter_3d_Untextured.vsh
//
//  Copyright (c) 2012 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

#define DECOMPRESSION_MULTIPLIER_POSITION   (1.0 / 32767.0)
#define DECOMPRESSION_MULTIPLIER_UV         (1.0 / 1024.0)

#define PI          3.1415926
#define PI20        (PI*2.0)
#define PI05        (PI*0.5)
#define PI20_RCP    (1.0 / PI20)

//------------------------------------------------------------------------------

attribute highp vec4 attrib_position;
attribute highp vec3 attrib_normal;
attribute highp vec4 attrib_rgba;
attribute highp vec2 attrib_uv0;

//------------------------------------------------------------------------------

uniform highp mat4 uniform_modelViewProjectionMatrix;
uniform highp vec4 uniform_animUV;
uniform mediump vec4 uniform_portalSettings;

//------------------------------------------------------------------------------

varying lowp vec4 varying_colour;
varying mediump vec2 varying_uv0;
varying mediump vec2 varying_uv1;

//------------------------------------------------------------------------------

mediump vec2 UVRotator(mediump vec2 UV, mediump float RotationAmount, mediump vec2 Pivot, mediump float Time)
{
    mediump vec2 result;

    mediump vec2 SubOp = (UV - Pivot);
    mediump float MulOp = (RotationAmount * Time);
    mediump float CosOp = cos(MulOp);
    mediump float SinOp = sin(MulOp);
    mediump float NegateOp = -(SinOp);
    mediump vec2 VectorConstruct = vec2(CosOp, NegateOp);
    mediump float DotOp = dot(SubOp, VectorConstruct.xy);
    mediump vec2 VectorConstruct1407 = vec2(SinOp, CosOp);
    mediump float DotOp1408 = dot(SubOp, VectorConstruct1407.xy);
    mediump vec2 VectorConstruct1409 = vec2(DotOp, DotOp1408);
    mediump vec2 AddOp = (Pivot + VectorConstruct1409.xy);
    
    result = AddOp;

    return result;
}

//------------------------------------------------------------------------------

void main()
{
    varying_colour = attrib_rgba;

    // Set up the animated uv coordinates...
    mediump vec2    baseUVOffset0 = fract(uniform_animUV.xy * (uniform_animUV.zw * -1.0));
    mediump vec2    baseUVOffset1 = fract(uniform_animUV.xy * uniform_portalSettings.xy * -PI20_RCP) * PI20;

    varying_uv0 = (attrib_uv0 * DECOMPRESSION_MULTIPLIER_UV);

    mediump vec2    uvRot0 = UVRotator(varying_uv0, baseUVOffset1.x, vec2(0.5, 0.5), 1.0);
    mediump vec2    uvRot1 = UVRotator(varying_uv0, baseUVOffset1.y, vec2(0.5, 0.5), 1.0);
    
    varying_uv1 = (varying_uv0 + baseUVOffset0 + (uvRot0 * uvRot1));

    highp vec3      posScaled   = (attrib_position.xyz * (attrib_position.w * DECOMPRESSION_MULTIPLIER_POSITION));
    highp vec4      posScaled4  = vec4(posScaled, 1.0);

    gl_Position = (uniform_modelViewProjectionMatrix * posScaled4);
}

//------------------------------------------------------------------------------
