//
//  Shader_PreLitTexReflectiveWater.vsh
//  CityBuilder
//
//  Created by Lee Metcalfe on 11/06/2011.
//  Copyright (c) 2011 Midoki Ltd. All rights reserved.
//

//------------------------------------------------------------------------------

attribute vec4 attrib_position;

//------------------------------------------------------------------------------

uniform highp	mat4	modelViewProjectionMatrix;

//------------------------------------------------------------------------------

//varying highp	vec3	texCoordVarying;	// highp needed to avoid inaccuracies in the anim uv's
varying highp vec2	texCoordVarying;

//------------------------------------------------------------------------------

void main()
{
    // Transform the position into screen space.
	vec3 posScaled = (attrib_position.xyz * (attrib_position.w * (1.0 / 32767.0)));
	vec4 posScaled4 = vec4(posScaled, 1.0);
	vec4 posTrans = modelViewProjectionMatrix * posScaled4;
	
	// Improve performance by flattening to polygons to 2D...
	// ...the depth is lost but that's ok in this case and it allows us to avoid a dependent texture read in the pixel shader!
	posTrans.xy = (posTrans.xy / posTrans.w);
	posTrans.zw = vec2(1.0, 1.0);

	gl_Position = posTrans;

////	texCoordVarying.xy = (posTrans.xy / posTrans.w);
////	texCoordVarying.xy = ((texCoordVarying.xy * 0.5) + 0.5);
//	texCoordVarying.xyz = posTrans.xyw;
	texCoordVarying.xy = ((posTrans.xy / posTrans.w) * 0.5) + 0.5;;
}

//------------------------------------------------------------------------------
